unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls, TypInfo, MultiMon, Math, MultiMonitorParam;

type
  TForm1 = class(TForm)
    Button1: TButton;
    Panel1: TPanel;
    MaxAlignRadioGroup: TRadioGroup;
    Button2: TButton;
    Button3: TButton;
    Button4: TButton;
    Button5: TButton;
    Button6: TButton;
    Button7: TButton;
    procedure Button1Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure Panel1Resize(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure MaxAlignRadioGroupClick(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure Button4Click(Sender: TObject);
    procedure Button5Click(Sender: TObject);
    procedure Button6Click(Sender: TObject);
    procedure Button7Click(Sender: TObject);
  private
    { Private 錾 }
    FMultiMonitorMaxInfoCalc: TMultiMonitorMaxInfoCalc;

    // ő剻WM_GETMINMAXINFOŃtH[̑傫𒲐ۂ
    // tH[ړłĂ܂̂h~邽߂̃R[h
    procedure WMSysCommand(var Message: TWMSysCommand); message WM_SYSCOMMAND;

    // tH[̑傫ƈʒu̐
    procedure WMGetMinMaxInfo(var msg : TWMGetMinMaxInfo); message WM_GETMINMAXINFO;
  public
    { Public 錾 }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

{ TForm1 }

procedure TForm1.WMSysCommand(var Message: TWMSysCommand);
begin
  if IsZoomed(Self.Handle) and ((Message.CmdType and $FFF0) = SC_MOVE) then
  begin
    Exit;
  end;
  inherited;
end;

procedure TForm1.Button1Click(Sender: TObject);
var
  WkMonitorInfo: TMonitorInfo;
  WkDisplayMonitorInfo: TMonitorInfo;
begin
  //}`j^ΉGetMonitorInfog
  WkMonitorInfo := FMultiMonitorMaxInfoCalc.MonitorInfo;
  WkDisplayMonitorInfo := FMultiMonitorMaxInfoCalc.DisplayMonitorInfo;

  ShowMessage(
    'j^̏' + #13#10 +
    'j^̐(1`?):' +
    IntToStr(FMultiMonitorMaxInfoCalc.MonitorCount) + #13#10 + 'tH[\Ă郂j^ԍ(0`?):' + IntToStr(Self.Monitor.MonitorNum) + #13#10#13#10 +
    'j^̈ʒuƃTCY\ivC}j^㌴_j' + #13#10 +
    'Left  :' + IntToStr(WkMonitorInfo.rcMonitor.Left) + #13#10 +
    'Top   :' + IntToStr(WkMonitorInfo.rcMonitor.Top) + #13#10 +
    'Right :' + IntToStr(WkMonitorInfo.rcMonitor.Right) + #13#10 +
    'Bottom:' + IntToStr(WkMonitorInfo.rcMonitor.Bottom) + #13#10#13#10 +
    'Lʂ̃j^̈ʒuƃTCY\ivC}j^㌴_j' + #13#10 +
    'Left  :' + IntToStr(WkMonitorInfo.rcWork.Left) + #13#10 +
    'Top   :' + IntToStr(WkMonitorInfo.rcWork.Top) + #13#10 +
    'Right :' + IntToStr(WkMonitorInfo.rcWork.Right) + #13#10 +
    'Bottom:' + IntToStr(WkMonitorInfo.rcWork.Bottom) + #13#10#13#10 +
    'j^̈ʒuƃTCY\ie탂j^㌴_j' + #13#10 +
    'Left  :' + IntToStr(WkDisplayMonitorInfo.rcMonitor.Left) + #13#10 +
    'Top   :' + IntToStr(WkDisplayMonitorInfo.rcMonitor.Top) + #13#10 +
    'Right :' + IntToStr(WkDisplayMonitorInfo.rcMonitor.Right) + #13#10 +
    'Bottom:' + IntToStr(WkDisplayMonitorInfo.rcMonitor.Bottom) + #13#10#13#10 +
    'Lʂ̃j^̈ʒuƃTCY\ie탂j^㌴_j' + #13#10 +
    'Left  :' + IntToStr(WkDisplayMonitorInfo.rcWork.Left) + #13#10 +
    'Top   :' + IntToStr(WkDisplayMonitorInfo.rcWork.Top) + #13#10 +
    'Right :' + IntToStr(WkDisplayMonitorInfo.rcWork.Right) + #13#10 +
    'Bottom:' + IntToStr(WkDisplayMonitorInfo.rcWork.Bottom));
end;

procedure TForm1.WMGetMinMaxInfo(var msg: TWMGetMinMaxInfo);
begin
  // OnCreateOɃCxgĂ܂u
  if FMultiMonitorMaxInfoCalc <> nil then
  begin
    FMultiMonitorMaxInfoCalc.WMGetMinMaxInfo(msg);
  end;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  FMultiMonitorMaxInfoCalc := TMultiMonitorMaxInfoCalc.Create(Self);
  FMultiMonitorMaxInfoCalc.TargetForm := Self;
  FMultiMonitorMaxInfoCalc.MaxSizeX := 800;
  FMultiMonitorMaxInfoCalc.MaxSizeY := 800;
  FMultiMonitorMaxInfoCalc.MaxPositionX := 10;
  FMultiMonitorMaxInfoCalc.MaxPositionY := 10;

  MaxAlignRadioGroup.ItemIndex := Ord(FMultiMonitorMaxInfoCalc.MaxAlign);
end;

procedure TForm1.Panel1Resize(Sender: TObject);
begin
  Self.Caption := Self.Caption + 'r';
end;

procedure TForm1.FormDestroy(Sender: TObject);
begin
  FreeAndNil(FMultiMonitorMaxInfoCalc);
end;

procedure TForm1.MaxAlignRadioGroupClick(Sender: TObject);
begin
  FMultiMonitorMaxInfoCalc.MaxAlign := TAlign(MaxAlignRadioGroup.ItemIndex);
end;

procedure TForm1.Button2Click(Sender: TObject);
begin
  ShowMessage(
    'tH[̏' + #13#10 +
    'Top:' + IntToStr(Self.Top) + #13#10 +
    'Left:' + IntToStr(Self.Left) + #13#10 +
    'Width:' + IntToStr(Self.Width) + #13#10 +
    'Height:' + IntToStr(Self.Height) + #13#10 +
    'WindowState:' + GetEnumName(
    TypeInfo(TWindowState), Ord(Self.WindowState)) + #13#10 +
    'pl̏' + #13#10 +
    'Panel.Width:' + IntToStr(Panel1.Width) + #13#10 +
    'Panel.Height:' + IntToStr(Panel1.Height) + #13#10 +
    'E̕' + #13#10 +
    'SM_CXFRAME:' + IntToStr(GetSystemMetrics(SM_CXFRAME)) + #13#10 +
    'SM_CYFRAME:' + IntToStr(GetSystemMetrics(SM_CYFRAME)) + #13#10 +
    'SM_CXEDGE:' + IntToStr(GetSystemMetrics(SM_CXEDGE)) + #13#10 +
    'SM_CYEDGE:' + IntToStr(GetSystemMetrics(SM_CYEDGE)) + #13#10 +
    'SM_CXBORDER:' + IntToStr(GetSystemMetrics(SM_CXBORDER)) + #13#10 +
    'SM_CYBORDER:' + IntToStr(GetSystemMetrics(SM_CYBORDER)) + #13#10 +
    '^Cgo[̍' + #13#10 +
    'SM_CYCAPTION:' + IntToStr(GetSystemMetrics(SM_CYCAPTION)) + #13#10 +
    'SM_CYSMCAPTION:' + IntToStr(GetSystemMetrics(SM_CYSMCAPTION))
    );
end;

procedure TForm1.Button3Click(Sender: TObject);
begin
  FMultiMonitorMaxInfoCalc.SetFormSafePosition;
end;

procedure TForm1.Button4Click(Sender: TObject);
begin
  if Self.WindowState = wsMaximized then
  begin
    Self.WindowState := wsNormal;
  end
  else begin
    Self.WindowState := wsMaximized;
  end;
end;

procedure TForm1.Button5Click(Sender: TObject);
begin
  FMultiMonitorMaxInfoCalc.WMGetMinMaxInfo2;
end;

procedure TForm1.Button6Click(Sender: TObject);
begin
  if FMultiMonitorMaxInfoCalc.TargetForm = nil then
  begin
    FMultiMonitorMaxInfoCalc.TargetForm := Self;
  end
  else begin
    FMultiMonitorMaxInfoCalc.TargetForm := nil;
  end;
end;

procedure TForm1.Button7Click(Sender: TObject);
begin
  Self.Close;
end;

end.
